﻿-- #######################################################
-- DEV NOTES
-- SEE: http://lua-users.org/wiki/TablesTutorial
-- SEE: http://www.wowwiki.com/Lua_functions
-- #######################################################







-- #######################################################
-- Var ini
-- #######################################################
local DCoordsINIComplete = false;

DCEnableDrag = 0;
DCShowZone = 1;
DCShowSubZone = 1;
DCSingleDecimal = 0;
DCBgAlpha = 1;
DCShowBackground = 0;
DCVisible = 1;
DCWorldMapVisible = 1;
DCWidth = 360;
DCScale = 1;
DCAlpha = 1;
DCR = 1;
DCG = 1;
DCB = 1;

DCMenuVisible = 0;


-- #######################################################



-- #######################################################
-- WORLD MAP STUFF

local UpdateFrame = CreateFrame("Frame");
UpdateFrame.name = "DCoordsUpdateEventFrame";
UpdateFrame:SetScript("OnUpdate", function(self,elapsed)
	--trace("TEST");
	handleOnUpdate(self,elapsed);
end);



Coordinates_worldMapText = WorldMapButton:CreateFontString()
Coordinates_worldMapText:SetTextColor(1, 1, 1)
Coordinates_worldMapText:SetPoint("BOTTOM", WorldMapButton, "BOTTOM", 0, 10)

local fontSize = 11
local fontStyle = "Fonts\\FRIZQT__.TTF"
local fontOutline = "OUTLINE"

scaledFontSize = fontSize / WorldMapDetailFrame:GetEffectiveScale();
Coordinates_worldMapText:SetFont(fontStyle, scaledFontSize, fontOutline);
Coordinates_worldMapText:SetText("DCoords");
-- #######################################################




-- #######################################################
-- OnLoad function
-- #######################################################
function handleOnLoad(self)
	trace("");
	trace("DCoords");
	trace("DCoords: Right click coordinates frame for menu.");
	trace("DCoords: Type /dc for more options");
	trace("DCoords: Got problems? Type /DC Reset");
	trace(" ");
	
	
	-- Setup events
	self:RegisterEvent('VARIABLES_LOADED');
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	
	
	-- World map var ini
	if (not CoordinatesDB) then
		CoordinatesDB = {}
		CoordinatesDB["worldmap"] = true
		CoordinatesDB["minimap"] = true
	end
	
	
	
	
end
-- #######################################################












-- #######################################################
-- Event handlers
-- #######################################################
function handleOnEvent(self, event, ...)
	----trace("DCoords: handleOnEvent event = " .. event);
	
	if (event == "ZONE_CHANGED_NEW_AREA") then
		
	end
	
	
	if (event == 'VARIABLES_LOADED') then		
		setupInterfaceMenu();
		setupSlashCommands();
		iniStates();
	end
end
-- #######################################################





-- #######################################################
function iniStates()
	--trace("DCoords: iniStates()");
	checkBoxEvent("cbEnableDrag",DCEnableDrag);
	checkBoxEvent("cbShowZone",DCShowZone);
	checkBoxEvent("cbShowSubZone",DCShowSubZone);
	checkBoxEvent("cbSingleDecimal",DCSingleDecimal);
	checkBoxEvent("cbShowBackground",DCShowBackground);
	checkBoxEvent("cbShowCoordinates",DCVisible);
	checkBoxEvent("cbShowWorldMapCoordinates",DCWorldMapVisible);
	
	-- Set worldmap checkbox to match (TO DO EVENT HOOK IS LOST - leave to menu for now)
	--local cb = _G["DCoordsWorldMapCB"];
	--cb:SetChecked(true);
	
	sliderEvent("sliderFrameAlpha",DCAlpha);
	sliderEvent("sliderFrameScale",DCScale);
	sliderEvent("sliderBgAlpha",DCBgAlpha);
	sliderEvent("sliderFrameWidth",DCWidth);
	
	sliderEvent("sliderTextR",DCR);
	sliderEvent("sliderTextG",DCG);
	sliderEvent("sliderTextB",DCB);
	
	
	DCoordsLocationText:SetTextColor(DCR,DCG,DCB);
end
-- #######################################################








-- ############################################################################################################################################################
-- CHECKBOX EVENTS
-- ############################################################################################################################################################
function checkBoxEvent(id,state)
	----trace("checkBoxEvent id:[" .. id .. "] state:" .. state);
	
	local DCoordsFrame = _G["DCoords"];
	
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	if id == "cbEnableDrag" and state == 1 then
		--trace("DCoords: Drag enabled");
		local cb = _G["cbEnableDrag"];
		cb:SetChecked(true);
		DCEnableDrag = 1;
	end
	
	if id == "cbEnableDrag" and state == 0 then
		--trace("DCoords: Drag disabled");
		local cb = _G["cbEnableDrag"];
		cb:SetChecked(false);
		DCEnableDrag = 0;
	end
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	
	
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	if id == "cbShowZone" and state == 1 then
		--trace("DCoords: Enabling zone text");
		local cb = _G["cbShowZone"];
		cb:SetChecked(true);
		DCShowZone = 1;
	end
	
	if id == "cbShowZone" and state == 0 then
		--trace("DCoords: Disabling zone text");
		local cb = _G["cbShowZone"];
		cb:SetChecked(false);
		DCShowZone = 0;
	end
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	
	
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	if id == "cbShowSubZone" and state == 1 then
		--trace("DCoords: Enabling sub zone");
		local cb = _G["cbShowSubZone"];
		cb:SetChecked(true);
		DCShowSubZone = 1;
	end
	
	if id == "cbShowSubZone" and state == 0 then
		--trace("DCoords: Disabling sub zone");
		local cb = _G["cbShowSubZone"];
		cb:SetChecked(false);
		DCShowSubZone = 0;
	end
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	
	
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	if id == "cbSingleDecimal" and state == 1 then
		--trace("DCoords: Single decimal place enabled");
		local cb = _G["cbSingleDecimal"];
		cb:SetChecked(true);
		DCSingleDecimal = 1;
	end
	
	if id == "cbSingleDecimal" and state == 0 then
		--trace("DCoords: Two decimal places enabled");
		local cb = _G["cbSingleDecimal"];
		cb:SetChecked(false);
		DCSingleDecimal = 0;
	end
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	
	
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	if id == "cbShowBackground" and state == 1 then
		--trace("DCoords: Coordinates background frame is now visible.");
		local cb = _G["cbShowBackground"];
		cb:SetChecked(true);
		DCShowBackground = 1;
		DCoords:SetBackdropColor(1,1,1,1);
		DCoords:SetBackdropBorderColor(1,1,1,1);
	end
	
	if id == "cbShowBackground" and state == 0 then
		--trace("DCoords: Coordinates background frame is now hidden.");
		local cb = _G["cbShowBackground"];
		cb:SetChecked(false);
		DCShowBackground = 0;
		DCoords:SetBackdropColor(1,1,1,0);
		DCoords:SetBackdropBorderColor(1,1,1,0);
	end
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	
	
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	if id == "cbShowCoordinates" and state == 1 then
		--trace("DCoords: In game coordinates visible");
		DCoordsFrame:Show();
		local cb = _G["cbShowCoordinates"];
		cb:SetChecked(true);
		DCVisible = 1;
	end
	
	if id == "cbShowCoordinates" and state == 0 then
		--trace("DCoords: In game coordinates hidden");
		DCoordsFrame:Hide();
		local cb = _G["cbShowCoordinates"];
		cb:SetChecked(false);
		DCVisible = 0;
	end
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	
	
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	if id == "cbShowWorldMapCoordinates" and state == 1 then
		--trace("DCoords: World map coordinates are now visible");
		--DCoordsFrame:Show();
		local cb = _G["cbShowWorldMapCoordinates"];
		cb:SetChecked(true);
		DCWorldMapVisible = 1;
		Coordinates_worldMapText:Show();
	end
	
	if id == "cbShowWorldMapCoordinates" and state == 0 then
		--trace("DCoords: World map coordinates are now hidden");
		--DCoordsFrame:Hide();
		local cb = _G["cbShowWorldMapCoordinates"];
		cb:SetChecked(false);
		DCWorldMapVisible = 0;
		Coordinates_worldMapText:Hide();
	end
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
end
-- ############################################################################################################################################################







-- ############################################################################################################################################################
-- SLIDER EVENTS
-- ############################################################################################################################################################
function sliderEvent(id,value)
	--trace("sliderEvent id:[" .. id .. "] value:" .. value);
	
	local DCoordsFrame = _G["DCoords"];
	
	
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	if id == "sliderFrameWidth" then
		local slider = _G["sliderFrameWidth"];
		getglobal(slider:GetName() .. 'Text'):SetText(string.format("%.2f",value));
		DCWidth = value;
		DCoordsFrame:SetWidth(DCWidth);
		DCoordsLocationTextFrame:SetWidth((DCWidth-10));
		slider:SetValue(DCWidth);
	end
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	
	
	
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	if id == "sliderFrameScale" then
		local slider = _G["sliderFrameScale"];
		getglobal(slider:GetName() .. 'Text'):SetText(string.format("%.2f",value));
		DCScale = value;
		DCoordsFrame:SetScale(DCScale);
		slider:SetValue(DCScale);
	end
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	
	
	

	
	
	
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	if id == "sliderAlpha" then
		local slider = _G["sliderAlpha"];
		getglobal(slider:GetName() .. 'Text'):SetText(string.format("%.2f",value));
		DCoordsFrame:SetAlpha(value);
		DCAlpha = value;
		slider:SetValue(DCAlpha);
	end
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	
	
	
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	if id == "sliderBgAlpha" then
		if DCShowBackground == 0 then
			return;
		end
		
		local slider = _G["sliderBgAlpha"];
		getglobal(slider:GetName() .. 'Text'):SetText(string.format("%.2f",value));
		DCBgAlpha = value;		
		DCoords:SetBackdropColor(1,1,1,DCBgAlpha);
		DCoords:SetBackdropBorderColor(1,1,1,DCBgAlpha);
		slider:SetValue(DCBgAlpha);
	end
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	
	
	
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	if id == "sliderTextR" then
		local slider = _G["sliderTextR"];
		getglobal(slider:GetName() .. 'Text'):SetText(string.format("%.2f",value));
		DCR = value;
		DCoordsLocationText:SetTextColor(DCR,DCG,DCB);
		slider:SetValue(DCR);
	end
	if id == "sliderTextG" then
		local slider = _G["sliderTextG"];
		getglobal(slider:GetName() .. 'Text'):SetText(string.format("%.2f",value));
		DCG = value;
		DCoordsLocationText:SetTextColor(DCR,DCG,DCB);
		slider:SetValue(DCG);
	end
	if id == "sliderTextB" then
		local slider = _G["sliderTextB"];
		getglobal(slider:GetName() .. 'Text'):SetText(string.format("%.2f",value));
		DCB = value;
		DCoordsLocationText:SetTextColor(DCR,DCG,DCB);
		slider:SetValue(DCB);
	end
	-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #	
	

end
-- ############################################################################################################################################################

